/***********************************************************************************/
/**	\file				StringDat.cpp
**	\brief				Implementation zur Klasse StringDat
*************************************************************************************
**	Autor:				Christian Roesch
**
**	Erstelldatum:		28.03.2002
**	letzte Aenderung:	28.03.2002
*************************************************************************************
**	-tut nichts-
**
************************************************************************************/


// includes
#include "StringDat.h"

// Methoden-Definitionen

/************************************************************************************
**	Methode:			StringDat::StringDat
************************************************************************************/
/**	Konstruktor
***
************************************************************************************/
StringDat::StringDat(void)
{
	FILE* pfileIn;

	char pcFileName[64];

	printf("TXT-File ? [Press Enter for standard] >");
	gets(pcFileName);

	if (pcFileName[0] == 0)
	{
		strcpy(pcFileName,"texte");
	}

	strcat(pcFileName,".txt");

	pfileIn = fopen(pcFileName,"rt");

	if (pfileIn == NULL)
	{
		printf("Datei is futsch!\n");
		exit(1);
	}

	readLine((char*)m_ppcSSP[ID_SCHERE],32,pfileIn);
	readLine((char*)m_ppcSSP[ID_STEIN],32,pfileIn);
	readLine((char*)m_ppcSSP[ID_PAPIER],32,pfileIn);
	readLine((char*)m_ppcSSP[ID_ENDE],32,pfileIn);

	readLine((char*)m_ppcWahl[ID_HUMAN],128,pfileIn);
	readLine((char*)m_ppcWahl[ID_CPU],128,pfileIn);

	readLine((char*)m_ppcSieg[ID_HUMAN],128,pfileIn);
	readLine((char*)m_ppcSieg[ID_CPU],128,pfileIn);
	readLine((char*)m_ppcSieg[ID_NONE],128,pfileIn);

	readLine((char*)m_pcWahlText,256,pfileIn);

	readLine((char*)m_pcUnknownText,256,pfileIn);

	fclose(pfileIn);

	srand( (unsigned)time( NULL ) );
}

/************************************************************************************
**	Methode:			StringDat::readline
************************************************************************************/
/**	liest eine Zeile aus dem File, schreib sie in den char* ud lscht das \n (falls
***	es da ist)
************************************************************************************/
void 	StringDat::readLine(char* pcDest,int iMax, FILE* pfileIn)
{
		fgets(pcDest,iMax,pfileIn);
		if (pcDest[strlen(pcDest)-1]==10)
		{
			pcDest[strlen(pcDest)-1]=0;
		}
}

/************************************************************************************
**	Methode:			StringDat::SSP
************************************************************************************/
/**	Gibt den zur ID passenden Text aus
***
************************************************************************************/
void StringDat::SSP(SSPID sspID)
{
	if (sspID != ID_UNKNOWN)
	{
		printf("%s",m_ppcSSP[sspID]);
	}
	else
	{
		printf("UNKNOWN");
	}
}

/************************************************************************************
**	Methode:			StringDat::Regeln
************************************************************************************/
/**	Gibt die Regeln aus.
***
************************************************************************************/
void StringDat::Regeln(void)
{
	printf("Es gelten folgende Regeln:\n");
	
	SSP(ID_SCHERE);
	printf(" schlaegt ");
	SSP(ID_PAPIER);
	printf("\n");

	SSP(ID_PAPIER);
	printf(" schlaegt ");
	SSP(ID_STEIN);
	printf("\n");

	SSP(ID_STEIN);
	printf(" schlaegt ");
	SSP(ID_SCHERE);
	printf("\n\n");
}

/************************************************************************************
**	Methode:			StringDat::Wahl
************************************************************************************/
/**	Fordert zum Whlen auf.
***
************************************************************************************/
void StringDat::Wahl(void)
{
	printf("%s",m_pcWahlText);
	
	SSP(ID_SCHERE);
	printf(", ");
	SSP(ID_STEIN);
	printf(" oder ");
	SSP(ID_PAPIER);
	printf("?\nOder ");
	SSP(ID_ENDE);
	printf(" zum Beenden.\n>");
}

/************************************************************************************
**	Methode:			StringDat::Wahl
************************************************************************************/
/**	Gibt die wahl des Spielers aus.
***
************************************************************************************/
void StringDat::Wahl(SSPID  sspID)
{
	printf ("%s",m_ppcWahl[ID_HUMAN]);
	SSP(sspID);
	printf ("\n");
}

/************************************************************************************
**	Methode:			StringDat::Vertippt
************************************************************************************/
/**	Gibt den Text aus, wenn Wort nicht erkannt wurde...
***
************************************************************************************/
void StringDat::Vertippt(void)
{
	printf("%s\n",m_pcUnknownText);
}

/************************************************************************************
**	Methode:			StringDat::getChoiceFromChar
************************************************************************************/
/**	berprft ob der String eine koreckte Auswahlmglichkeit ist
***
************************************************************************************/
SSPID StringDat::getChoiceFromChar(char* pcText)
{
	int iCount;

	for(iCount=0; iCount<c_iNrOfStrings; iCount++)
	{
		if (_stricmp(pcText,(char*)m_ppcSSP[iCount]) == 0)
		{
			return (SSPID) iCount;
		}
	}

	return ID_UNKNOWN;
}

/************************************************************************************
**	Methode:			StringDat::Auswertung
************************************************************************************/
/**	Whlt fr den Computer und wertet aus, wer gewinnt...
************************************************************************************/
void StringDat::Auswertung(SSPID sspPlayer)
{
	SSPID sspCPU=(SSPID) (rand()%3);		

	printf ("%s",m_ppcWahl[ID_CPU]);
	SSP(sspCPU);
	printf ("\n");

	if (sspPlayer == sspCPU)
	{
		printf("%s\n\n",m_ppcSieg[ID_NONE]);
		return;
	}

	if ((sspPlayer+1)%3 == sspCPU)
	{
		printf("%s\n\n",m_ppcSieg[ID_CPU]);
		return;
	}

	printf("%s\n\n",m_ppcSieg[ID_HUMAN]);
	return;
}

/************************************************************************************
**	Ende der Datei:		StringDat.cpp
************************************************************************************/
