/***********************************************************************************/
/**	\file				StringDat.h
**	\brief				Header File zur Klasse StringDat
*************************************************************************************
**	Autor:				Christian Roesch
**
**	Erstelldatum:		28.03.2002
**	letzte Aenderung:	28.03.2002
*************************************************************************************
**	Verwaltet die Strings die fr SSP ntig sind.
************************************************************************************/

#ifndef _StringDat_H
#define _StringDat_H

// includes
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

const int c_iNrOfStrings=4;

enum SSPID
{
	ID_SCHERE,
	ID_STEIN,
	ID_PAPIER,
	ID_ENDE,
	ID_UNKNOWN
};

enum PlayerID
{
	ID_CPU,
	ID_HUMAN,
	ID_NONE
};
// Klassen-Deklaration

/***********************************************************************************/
/** \brief	StringDat verwaltet Texte
*************************************************************************************
**	Ldt zu Beginn die Textmeldungen aus texte.txt und kann diese dann ausgeben
************************************************************************************/

class	StringDat
{
public:
	StringDat (void);

void	SSP(SSPID sspID);

SSPID	getChoiceFromChar(char* pcText);

void	Wahl(SSPID sspID);

void	Auswertung(SSPID sspPlayer);

void	Wahl(void);

void	Regeln(void);

void	Vertippt(void);
protected:

private:
void 	readLine(char* pcDest,int iMax, FILE* pfileIn);

	char**	m_ppcSSP[c_iNrOfStrings][32];
	char**	m_ppcWahl[2][128];
	char**	m_ppcSieg[3][128];

	char*	m_pcWahlText[256];
	char*	m_pcUnknownText[256];
};

#endif//_StringDat_H

class	StringDat;


/************************************************************************************
**	Ende der Datei:		StringDat.h
************************************************************************************/